"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CancerInterpretedGenome(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "analysisId",
        "referenceDatabasesVersions",
        "reportRequestId",
        "reportUri",
        "reportedStructuralVariants",
        "reportedVariants",
        "softwareVersions",
        "versionControl",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "reportedStructuralVariants": reports_4_2_0.ReportedStructuralVariantCancer,
            "reportedVariants": reports_4_2_0.ReportedVariantCancer,
            "versionControl": reports_4_2_0.ReportVersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "org.gel.models.report.avro.ReportedStructuralVariantCancer": reports_4_2_0.ReportedStructuralVariantCancer,
            "org.gel.models.report.avro.ReportedVariantCancer": reports_4_2_0.ReportedVariantCancer,
            "org.gel.models.report.avro.ReportVersionControl": reports_4_2_0.ReportVersionControl,
            "org.gel.models.report.avro.CancerInterpretedGenome": reports_4_2_0.CancerInterpretedGenome,
        }

    __slots__ = [
        "analysisId",
        "referenceDatabasesVersions",
        "reportRequestId",
        "reportUri",
        "reportedStructuralVariants",
        "reportedVariants",
        "softwareVersions",
        "versionControl",
        "comments",
    ]

    def __init__(
        self,
        analysisId,
        referenceDatabasesVersions,
        reportRequestId,
        reportUri,
        reportedStructuralVariants,
        reportedVariants,
        softwareVersions,
        versionControl,
        comments=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_4_2_0.CancerInterpretedGenome model.

        :param analysisId:
            This is the ID of the analysis carried out and is expected to be
            linked to the conditions and parameters         used to
            produce the clinical interpretation over this group of
            samples. It is critical to establish provenance.
            It is expected that this id can be used to retrieve an
            analysis in the decision support/ variant exploration
            tools
        :type analysisId: str
        :param referenceDatabasesVersions:
            This map should contains the version of the different DBs used in the
            process
        :type referenceDatabasesVersions: dict[str, str]
        :param reportRequestId:
            This is the ID of the clinical interpretation request
        :type reportRequestId: str
        :param reportUri:
            URI where the company can upload files for this analysis
        :type reportUri: str
        :param reportedStructuralVariants:
            The reported structural variants for cancer
        :type reportedStructuralVariants: list[ReportedStructuralVariantCancer]
        :param reportedVariants:
            The reported small variants for cancer
        :type reportedVariants: list[ReportedVariantCancer]
        :param softwareVersions:
            This map should contains the version of the different software in the
            process
        :type softwareVersions: dict[str, str]
        :param versionControl:
            Model version number
        :type versionControl: ReportVersionControl
        :param comments:
            Comments about the report
        :type comments: None | list[str]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "4.2.0"
